it-swarm-ja.com

「openssl s_client」を使用してサーバーのSSL / TLS証明書を取得する

以下を使用して、ロードバランサーの1つ(Netscaler)のSSL/TLS証明書を取得しようとしています。

openssl s_client -showcerts -connect lb.example.com:443

ただし、証明書は表示されません。

CONNECTED(00000003)
write:errno=54

-servername lb.example.comを使用しても効果がなく、システム管理者から、ロードバランサーはSNIを使用しないと言われました。

編集:サーバーはイントラネット上にあり、公衆インターネットからの接続を受け入れません。これは-debugを指定したopensslの出力です。

CONNECTED(00000003)
write to 0x7fec7af0abf0 [0x7fec7b803a00] (130 bytes => 130 (0x82))
0000 - 80 80 01 03 01 00 57 00-00 00 20 00 00 39 00 00   ......W... ..9..
0010 - 38 00 00 35 00 00 16 00-00 13 00 00 0a 07 00 c0   8..5............
0020 - 00 00 33 00 00 32 00 00-2f 00 00 9a 00 00 99 00   ..3..2../.......
0030 - 00 96 03 00 80 00 00 05-00 00 04 01 00 80 00 00   ................
0040 - 15 00 00 12 00 00 09 06-00 40 00 00 14 00 00 11   [email protected]
0050 - 00 00 08 00 00 06 04 00-80 00 00 03 02 00 80 00   ................
0060 - 00 ff a6 f7 27 1a a7 18-85 cf b2 03 22 fc 48 3d   ....'.......".H=
0070 - dd a9 2c b7 76 67 62 80-df 85 ed 48 35 c7 d4 87   ..,.vgb....H5...
0080 - 8d d3                                             ..
read from 0x7fec7af0abf0 [0x7fec7b809000] (7 bytes => -1 (0xFFFFFFFFFFFFFFFF))
write:errno=54

そして、これはcurl -v https://lb.example.com/からの関連出力です:

$ curl -vI https://lb.exmple.com/
*   Trying 1.2.3.4...
* Connected to lb.exmple.com (10.1.2.3) port 443 (#0)
* TLS 1.2 connection using TLS_RSA_WITH_AES_256_CBC_SHA
* Server certificate: lb.example.com
* Server certificate: RapidSSL SHA256 CA - G2
* Server certificate: GeoTrust Primary Certification Authority - G3
> HEAD / HTTP/1.1
> Host: lb.exmple.com
> User-Agent: curl/7.43.0
> Accept: */*
>

openssl s_clientを使用して証明書を取得する方法に関する提案はありますか?

17
Daniel Serodio

しばらくして、私はそれを理解しました。この特定のロードバランサーは、OS X(0.9.8)に含まれているopensslのバージョンが理解できないTLSv1.2のみを使用するように構成されました。これが機能するように、homebrewを使用してopensslの新しいバージョン(> = 1.0.1)をインストールしました。

/usr/local/opt/openssl/bin/openssl s_client -showcerts -connect lb.example.com:443
21
Daniel Serodio

以下を使用して、ロードバランサーの1つ(Netscaler)のSSL/TLS証明書を取得しようとしています。

 openssl s_client -showcerts -connect lb.example.com:443

最新の構成(それが何を意味するかを放棄している人もいる)の場合は、次のようにします。

openssl s_client -connect lb.example.com:443 -tls1 -servername lb.example.com | \
openssl x509 -text -noout

CONNECTED(00000003)
write to 0x7fec7af0abf0 [0x7fec7b803a00] (130 bytes => 130 (0x82))
0000 - 80 80 01 03 01 00 57 00-00 00 20 00 00 39 00 00
...

バイト0と1に追加のプリアンブルがあるようです。バイト2にレコードタイプが必要です。バイト3と4にはバージョン番号が必要です。バイト5および6は、ペイロードの16ビット長である必要があります。

これが実際の例です:

$ openssl s_client -connect www.googl.com:443 -tls1 -servername www.googl.com -debug
CONNECTED(00000005)
write to 0x7f7fe1c1fa30 [0x7f7fe2022000] (132 bytes => 132 (0x84))
0000 - 16 03 01 00 7f 01 00 00-7b 03 01 71 c0 12 35 98
...

上記から、レコードタイプは位置0にあり、その値は0x16です。 0x16はハンドシェイクタイプです。レコードレイヤーのバージョンは、位置2および3の次の2バイトです。それらの値は0x03 0x01です。ペイロードの長さは0x007fです。

18ページの RFC 5246、The Transport Layer Security(TLS)Protocol Version 1.2 も参照してください。

6.2.1.  Fragmentation

   The record layer fragments information blocks into TLSPlaintext
   records carrying data in chunks of 2^14 bytes or less.  Client
   message boundaries are not preserved in the record layer (i.e.,
   multiple client messages of the same ContentType MAY be coalesced
   into a single TLSPlaintext record, or a single message MAY be
   fragmented across several records).

      struct {
          uint8 major;
          uint8 minor;
      } ProtocolVersion;

      enum {
          change_cipher_spec(20), alert(21), handshake(22),
          application_data(23), (255)
      } ContentType;

      struct {
          ContentType type;
          ProtocolVersion version;
          uint16 length;
          opaque fragment[TLSPlaintext.length];
      } TLSPlaintext;

問題は、古いSSLv2互換のレコードタイプである可能性があります。または、たとえば0.9.5または0.9.8のOpenSSLのダウンレベルバージョンである可能性があります。言うのは難しいので、おそらくもっと情報が必要です。

詳細にはOSが含まれます。 OpenSSLバージョン。プラットフォームのバージョンのOpenSSLを独自のバージョンのOpenSSLに置き換えようとした場合。ファイアウォールまたは「Web検査」ボックスまたはその他のミドルウェア機能が実行されている場合。サーバーが受け取るもの。


-servername lb.example.comを使用しても効果がなく、システム管理者から、ロードバランサーはSNIを使用しないと言われました。

これはちょっと珍しいですね。ただし、これはTLSの拡張機能であるため、使用しない場合は無視されます(致命的なアラートは生成されません)。

2016年の経験則:常にTLS 1.0以上を使用し、常にSNIを使用します。

3
jww